unit Dlmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Dslabel, Buttons, Balloon, Ledgadgt,
  Ifedlreg, Ifddlreg, Ifcdlreg, Ifbdlreg, OvcDT, OvcIntl, Printers, ifadlreg;

type
  TDemo = class(TForm)
    Panel9: TPanel;
    DSLabel1: TDSLabel;
    Panel1: TPanel;
    Image2: TImage;
    Panel2: TPanel;
    Image1: TImage;
    Panel3: TPanel;
    Memo1: TMemo;
    Panel4: TPanel;
    DigitalClockBtn: TSpeedButton;
    AnalogClockBtn: TSpeedButton;
    PrintTextBtn: TSpeedButton;
    Panel5: TPanel;
    Label1: TLabel;
    BalloonHint1: TBalloonHint;
    Panel7: TPanel;
    Label3: TLabel;
    Edit1: TEdit;
    Panel8: TPanel;
    Label4: TLabel;
    Edit2: TEdit;
    Panel10: TPanel;
    Label5: TLabel;
    Edit3: TEdit;
    Panel11: TPanel;
    Label6: TLabel;
    Edit4: TEdit;
    Panel12: TPanel;
    Label7: TLabel;
    Edit5: TEdit;
    Panel6: TPanel;
    Label2: TLabel;
    Edit6: TEdit;
    Panel13: TPanel;
    Label8: TLabel;
    Edit7: TEdit;
    Panel14: TPanel;
    LEDClock1: TLEDClock;
    ADemoLock1: TADemoLock;
    BDemoLock1: TBDemoLock;
    CDemoLock1: TCDemoLock;
    DDemoLock1: TDDemoLock;
    EDemoLock1: TEDemoLock;
    PrintDialog1: TPrintDialog;
    procedure AnalogClockBtnClick(Sender: TObject);
    procedure DigitalClockBtnClick(Sender: TObject);
    procedure PrintTextBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
public
    { Public declarations }
  end;

var
  Demo: TDemo;

implementation
{$R *.DFM}

{---------------------------------------------------------------}
procedure TDemo.FormCreate(Sender: TObject);
var
	Count : integer;
  FirstAccess, LastAccess : TDateTime;
  FDate, SDate : string;
const
	U = 'n/a';
begin
  	{setting current values to unknown}
    Edit1.Text := U;
  	Edit1.Update;
  	Edit2.Text := U;
  	Edit2.Update;
  	Edit3.Text := U;
  	Edit3.Update;
  	Edit4.Text := U;
  	Edit4.Update;
  	Edit5.Text := U;
  	Edit5.Update;
  	Edit6.Text := U;
  	Edit6.Update;
  	Edit7.Text := U;
  	Edit7.Update;

	{test days of executions (<14) using: TDDemoLock}
  if (DDemoLock1.AreDaysOK (FirstAccess, LastAccess, Count) = True) then
  begin
   	{show days of executions}
   	Edit4.Text := IntToStr (Count);
    Edit4.Update;
   	Edit6.Text := DateToStr (FirstAccess);
    Edit6.Update;
   	Edit7.Text := DateToStr (LastAccess);
    Edit7.Update;

   	{begin regular programming}
  	{load the information about DemoLock demonstration}
 		Memo1.Lines.LoadFromFile ('demolock.txt');
  end
  else
  begin
   	{show number of executions}
   	Edit4.Text := IntToStr (Count);
    Edit4.Update;
   	Edit6.Text := DateToStr (FirstAccess);
    Edit6.Update;
   	Edit7.Text := DateToStr (LastAccess);
    Edit7.Update;
  	ShowMessage ('Exceeded Days of Executions (14)');
    Application.Terminate;
  end;

  {test if DELPHI is running using : TADemoLock}
	Edit1.Text := 'No';
  if (ADemoLock1.IsDelphiRunning) then
 				Edit1.Text := 'Yes';

   Edit1.Update;

   {following two lines added to insure proper handling of international date}
   FDate := OvcIntlSup.InternationalDate (False);
   SDate := OvcIntlSup.DMYtoDateString (FDate, 30, 1, 96, False);

   CDemoLock1.ExpirationDate := StrToDate (SDate);
end;


procedure TDemo.AnalogClockBtnClick(Sender: TObject);
var
	First, Last : TDateTime;
begin
	{test if executions is within preset date (1-3-95) using: TBDemoLock}
  if (CDemoLock1.IsDateOK (First, Last) = True) then
  begin
		{displaying start date}
    Edit3.Text := DateToStr (First);
    Edit3.Update;

   	{begin regular programming}
    WinExec ('anaclck.exe', 0);
  end
  else
  begin
  	ShowMessage ('Analog Clock license has expired!');
  end;
end;


procedure TDemo.DigitalClockBtnClick(Sender: TObject);
var
	Seconds : Word;
begin
    {start of regular programming}
		if (DigitalClockBtn.Caption = 'Show Digital Clock') then
  	begin
			{test number of seconds (<300) using: TEDemoLock}
   		if (EDemoLock1.AreSecondsOK (Time, Seconds) = True) then
   		begin
   			{update seconds information}
	    	Edit5.Text := IntToStr (Seconds);
        Edit5.Update;

  	 		{regular programming}
 				Panel14.Visible := True;
				DigitalClockBtn.Caption := 'Hide Digital Clock'
      end
      else
      begin
   			{update seconds information}
	    	Edit5.Text := IntToStr (Seconds);
        Edit5.Update;
  			ShowMessage ('Exceeded Seconds (300)');
      end
    end
  	else
  	begin
  		Panel14.Visible := False;
			DigitalClockBtn.Caption := 'Show Digital Clock';

      {update EDemoLock}
      EDemoLock1.LogTime (Time);
  	end;
end;


procedure TDemo.PrintTextBtnClick(Sender: TObject);
var
	Count : Byte;
  i : integer;
  F : TextFile;
begin
	{test number of executions using: TBDemoLock}
  if (BDemoLock1.IsExecutionOK (Count) = True) then
  begin
   	{show number of executions}
   	Edit2.Text := IntToStr (Count);
    Edit2.Update;

   	{begin regular programming}
    if PrintDialog1.Execute then
    begin
	   	try
	    	AssignPrn (F);
   		 	Rewrite (F);
     	 	Printer.Canvas.Font.Assign (Memo1.Font);

      	for i := 0 to Memo1.Lines.Count -1 do
      		WriteLn (F, Memo1.Lines[i]);
      finally
      	CloseFile (F);
      end;
    end;
  end
  else
  begin
   	{show number of executions}
   	Edit2.Text := IntToStr (Count);
    Edit2.Update;
  	ShowMessage ('Exceeded Number of Executions (5)');
  end;
end;

end.
